/*
 * SimpleException.cpp
 *
 *  Created on: 12/mag/2011
 *      Author: bertini
 */

#include "SimpleException.h"
#include "BasicUtils.h"

SimpleException::~SimpleException() throw () {
}

SimpleException::SimpleException(std::string problemDescription, std::string fname, int line, bool fatal) {
	msg = "";
	this->fatal = fatal;
	fileName = fname;
	fileLine = line;

	if (isFatal())
		msg = "FATAL ERROR: ";
	if (!fileName.empty())
		msg += "File: " + fileName;
	if (fileLine > 0)
		msg += " - Line: " + toString(fileLine);
	if (!problemDescription.empty())
		msg += " - Problem: " + problemDescription;
}

const char* SimpleException::what() const throw () {
	return msg.c_str();
}
