/*
 * SimpleException.h
 *
 *  Created on: 12/mag/2011
 *      Author: bertini
 */

#ifndef SIMPLEEXCEPTION_H_
#define SIMPLEEXCEPTION_H_

#include <exception>
#include <string>

// TODO extend this class
class SimpleException : public std::exception {
public:
	explicit SimpleException(std::string problemDescription, std::string fname="", int fileLine = -1, bool fatal = false);
	virtual ~SimpleException() throw(); // required by ~exception() throw() - see http://www.agapow.net/programming/cpp/looser-throw-specifier
	virtual const char* what() const throw();

	bool isFatal() const {
		return fatal;
	}
	int getLine() const {
		return fileLine;
	}
	std::string getFile() const {
		return fileName;
	}
	std::string getMessage() const {
		return msg;
	}

private:
	std::string msg;
	std::string fileName;
	int fileLine;
	bool fatal;
};

#endif /* SIMPLEEXCEPTION_H_ */
